#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>

#include <gnome.h>

int pppd_pid;

int strpos (const char *haystack, const char *needle) {
  int i;

  if (strlen (haystack) < strlen (needle))
    return -1;

  for (i = 0; i <= (strlen (haystack) - strlen(needle)); i++) {
    if (!strncmp (&haystack[i], needle, strlen(needle)))
      return i;
  }

  return -1;
}

/* FIXME: make it useful */
void parse (char* buf) {
  int pos;
  char *str_pid;

/* Sample str_pid: Aug  4 12:52:54 localhost pppd[xxxxx]: pppd 2.4.2 ... */

  if ((pos = strpos (buf, "pppd 2.4.2 started by")) > 0) {
    str_pid = malloc (pos - 34);
    strncpy (str_pid, &buf[31], pos - 34);
    pppd_pid = atoi (str_pid);
  }
}

void print (int fd, int offset, GtkTextBuffer *txt_log_buf) {
  char buf[offset + 1];

  read (fd, buf, offset);
  gtk_text_buffer_insert_at_cursor (txt_log_buf, buf, offset);
  parse (buf);
}

void tail (GtkTextBuffer *txt) {
  int fd;
  struct stat stats;
  long size = 0;

  /* FIXME: Error checking etc. */

  fd = open ("/var/log/ppp", O_RDONLY);
  lseek (fd, 0, SEEK_END);

  while (1) {

    fstat (fd, &stats);
    if (stats.st_size > size) {
      print (fd, stats.st_size - size, txt);
      size = stats.st_size;
    }

    sleep (1);

  }

  close (fd);

}
